import { NPTEventModel } from "@/types/event/NPTEventModel";
import { SchedulerProBaseConfig } from "@bryntum/schedulerpro";

import { eventRenderer } from "@/scheduler/lib/config/eventStyle";

/* eslint-disable @typescript-eslint/no-explicit-any */
type SchedulerProFeatures = {
  cellEditFeature: any;
  cellMenuFeature: any;
  cellTooltipFeature: any;
  columnAutoWidthFeature: any;
  columnDragToolbarFeature: any;
  columnLinesFeature: any;
  columnPickerFeature: any;
  columnReorderFeature: any;
  columnResizeFeature: any;
  contextMenuFeature: any;
  dependenciesFeature: any;
  dependencyEditFeature: any;
  eventContextMenuFeature: any;
  eventCopyPasteFeature: any;
  eventDragFeature: any;
  eventDragCreateFeature: any;
  eventDragSelectFeature: any;
  eventEditFeature: any;
  eventFilterFeature: any;
  eventMenuFeature: any;
  eventResizeFeature: any;
  eventTooltipFeature: any;
  excelExporterFeature: any;
  filterFeature: any;
  filterBarFeature: any;
  groupFeature: any;
  groupSummaryFeature: any;
  headerContextMenuFeature: any;
  headerMenuFeature: any;
  headerZoomFeature: any;
  labelsFeature: any;
  nonWorkingTimeFeature: any;
  panFeature: any;
  pdfExportFeature: any;
  percentBarFeature: any;
  quickFindFeature: any;
  regionResizeFeature: any;
  resourceNonWorkingTimeFeature: any;
  resourceTimeRangesFeature: any;
  rowCopyPasteFeature: any;
  rowReorderFeature: any;
  scheduleContextFeature: any;
  scheduleContextMenuFeature: any;
  scheduleMenuFeature: any;
  scheduleTooltipFeature: any;
  searchFeature: any;
  simpleEventEditFeature: any;
  sortFeature: any;
  stickyCellsFeature: any;
  stickyEventsFeature: any;
  stripeFeature: any;
  summaryFeature: any;
  taskEditFeature: any;
  timeAxisHeaderMenuFeature: any;
  timeRangesFeature: any;
  treeFeature: any;
};
/* eslint-enable @typescript-eslint/no-explicit-any */

const config: Partial<SchedulerProBaseConfig & SchedulerProFeatures> = {
  cellEditFeature: false,
  dependenciesFeature: { allowCreate: false },
  dependencyEditFeature: false,
  eventDragCreateFeature: false,
  eventDragFeature: { disabled: true },
  eventResizeFeature: { disabled: true },
  filterBarFeature: true,
  panFeature: true,
  sortFeature: true,
  stickyEventsFeature: false,
  stripeFeature: true,
  createEventOnDblClick: false,
  project: {
    adjustDurationToDST: true
  },
  eventStore: {
    modelClass: NPTEventModel,
    data: [
      {
        id: "969ffae2-6f5b-4f33-b9bd-77af543a8d8e",
        startDate: new Date("2023-03-19T23:00:00.000Z"),
        endDate: new Date("2023-03-26T23:00:00.000Z"),
        task: "Test Blocker 1",
        workcenter: "DC0A"
      },
      {
        id: "969ffae2-6f5b-4f33-b9bd-77af543a8d00",
        startDate: new Date("2023-03-19T23:00:00.000Z"),
        endDate: new Date("2023-03-26T23:00:00.000Z"),
        task: "Test Blocker 2",
        workcenter: "DC1A"
      },
      {
        id: "969ffae2-6f5b-4f33-b9bd-77af543a8d01",
        startDate: new Date("2023-03-19T23:00:00.000Z"),
        endDate: new Date("2023-03-24T23:00:00.000Z"),
        task: "Test Blocker 3",
        workcenter: "DC2A"
      }
    ]
  },
  infiniteScroll: true,
  multiEventSelect: true,
  snap: true,
  barMargin: 5,
  minZoomLevel: 3,
  // eventRenderer,

  resources: [
    {
      id: "DC0A",
      name: "DC0A"
    },
    {
      id: "DC1A",
      name: "DC1A"
    },
    {
      id: "DC2A",
      name: "DC2A"
    }
  ]
};

export const createSchedulerConfig = () => config;
