import { NPTEventProps } from "@/types/event/NPTEvent";
import { EventModel } from "@bryntum/schedulerpro";
import { NPTDataFieldConfig } from "./NPTDataFieldConfig";

const fields = [
  { name: "name", dataSource: "task", type: "string" },
  { name: "startDate", type: "date" },
  { name: "endDate", type: "date" },
  { name: "id", type: "string" },
  { name: "task", type: "string" },
  { name: "username", type: "string" },
  { name: "workcenter", type: "string" }
] as NPTDataFieldConfig[];

export class NPTEventModel extends EventModel implements NPTEventProps {
  id!: string | number;
  startDate!: Date;
  endDate!: Date;
  task!: string;
  workcenter!: string;
  name!: string;

  constructor(props: NPTEventProps) {
    super(props);
    this.name = props.task;
    this.resourceId = props.workcenter;
    this.startDate = props.startDate;
    this.endDate = props.endDate;
    this.id = props.id;
    this.task = props.task;
    this.workcenter = props.workcenter;
  }

  public static get fields() {
    return fields;
  }

  public field<ReturnType extends unknown, Property = typeof fields[number]["name"]>(
    key: Property
  ): ReturnType {
    return this.get((key as unknown) as string);
  }
}
